﻿using System;
using System.Windows;
using SLMultiThread.ThreadTools;

namespace SLMultiThread
{
    public partial class App : Application
    {

        public App()
        {
            Startup += Application_Startup;
            Exit += Application_Exit;
            UnhandledException += Application_UnhandledException;

            SmartDispatcher.Initialize(Deployment.Current.Dispatcher);   

            InitializeComponent();
        }

        private void Application_Startup(object sender, StartupEventArgs e)
        {
            RootVisual = new MainPage();
        }

        private void Application_Exit(object sender, EventArgs e)
        {

        }
        private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
        {
            // Si l'application s'exécute en dehors du débogueur, signalez l'exception à l'aide de
            // mécanisme d'exception du navigateur. Sur IE une icône verte s'affichera 
            // dans la barre d'état et dans Firefox un script d'erreur s'affichera.
            if (System.Diagnostics.Debugger.IsAttached) return;
            // REMARQUE : cela permet à l'application de continuer à s'exécuter après qu'une exception a été levée
            // mais pas gérée. 
            // Pour des applications de production, cette gestion des erreurs doit être remplacée par un système qui 
            // signale l'erreur au site Web et arrête l'application.
            e.Handled = true;
            Deployment.Current.Dispatcher.BeginInvoke(delegate { ReportErrorToDOM(e); });
        }
        private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
        {
            try
            {
                var errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
                errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

                System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight Application " + errorMsg + "\");");
            }
            catch (Exception)
            {
            }
        }
    }
}
